﻿<%@ WebService Language="C#" Class="WebService" %>

using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Data;
using System.Collections.Generic;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
[System.Web.Script.Services.ScriptService]
public class WebService  : System.Web.Services.WebService {

    [WebMethod(EnableSession = true)]
    public List<MyObject> GetData(int startRowIndex, int maximumRows)
    {
        DataSet ds = new DataSet();
        ds.ReadXml("http://blogs.telerik.com/Blogs.rss");
        DataTable table = ds.Tables["item"];

        int totalRows = table.Rows.Count;
        HttpContext.Current.Session["MyCount"] = totalRows;

        List<MyObject> list = new List<MyObject>();
        for (int i = 0; i < maximumRows; i++)
        {
            int index = startRowIndex + i;
            
            if (index >= totalRows) break;

            MyObject item = new MyObject();
            item.Title = table.Rows[index]["title"].ToString();
            item.Url = table.Rows[index]["link"].ToString();
            item.Content = table.Rows[index]["description"].ToString();
            item.Author = table.Rows[index]["author"].ToString();
            item.Date = DateTime.Parse(table.Rows[index]["pubDate"].ToString());
            list.Add(item);
        }

        return list;
    }

    [WebMethod(EnableSession = true)]
    public int GetCount()
    {
        return (int)HttpContext.Current.Session["MyCount"];
    }


    [WebMethod(EnableSession = true)]
    public List<MyObject> GetAtomData(int startRowIndex, int maximumRows)
    {
        DataSet ds = new DataSet();
        ds.ReadXml("http://news.google.com/news?ned=us&topic=b&output=atom");
        DataTable entryTable = ds.Tables["entry"];
        DataTable titleTable = ds.Tables["title"];
        DataTable contentTable = ds.Tables["content"];
        DataTable linkTable = ds.Tables["link"];
        DataTable authorTable = ds.Tables["author"];

        string author = authorTable.Rows[0]["name"].ToString();

        int totalRows = entryTable.Rows.Count;
        HttpContext.Current.Session["MyAtomCount"] = totalRows;

        List<MyObject> list = new List<MyObject>();
        for (int i = 0; i < maximumRows; i++)
        {
            int index = startRowIndex + i;

            if (index >= totalRows) break;
            
            MyObject item = new MyObject();
            item.Title = titleTable.Rows[index]["title_Text"].ToString();
            item.Url = linkTable.Rows[index]["href"].ToString();
            item.Content = contentTable.Rows[index]["content_Text"].ToString();
            item.Author = author;
            item.Date = DateTime.Parse(entryTable.Rows[index]["issued"].ToString());
            list.Add(item);
        }

        return list;
    }

    [WebMethod(EnableSession = true)]
    public int GetAtomCount()
    {
        return (int)HttpContext.Current.Session["MyAtomCount"];
    }

    public class MyObject
    {
        public string Title { get; set; }
        public string Url { get; set; }
        public string Content { get; set; }
        public string Author { get; set; }
        public DateTime Date { get; set; }
    }
    
}

